#!/opt/mambaforge/envs/bioconda/conda-bld/snoscan_1684116313927/_h_env_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placehold_placeh/bin/perl 

use Getopt::Std;

$opt_P = 0;
$opt_H = 0;
$opt_M = 0;
$opt_U = 0;
$opt_R = 0;
$opt_r = 0;
$opt_S = 0;
$opt_T = 50;
$opt_m = 200;
$opt_e = ".";
$opt_F = 0;

&getopts('PHMURrS:e:m:T:F');

$sort_by_site = $opt_P;
$sort_by_hit = $opt_H;
$unmapped_only = $opt_U;
$mapped_only = $opt_M;
$remove_dups = $opt_R;         # strong = both start & end bounds must match
$remove_dups = $opt_r;
$single_bound_match = $opt_r;  # weak = remove dups, only start bound must match
$key = $opt_e;
$Min_score = $opt_S;
$Max_score = $opt_m;
$Max_meth_hits = $opt_T;
$Filter_only = $opt_F;

if ($remove_dups) {
#    $sort_by_site = 1;
}

if ($#ARGV < 0) {
    die "\nUsage: sort-snos [options] <snoRNA hits file>\n\n",
    "   Sort snoRNA hits by overall score\n\n",
    "   where -P        :  sort snos by Position of complementarity on rRNA\n",
    "         -H        :  sort snos by position of hit in query sequence\n",
    "         -R        :  sort snos by position & Remove lower-scoring duplicate hits\n",
    "                       (both start & end bounds must match\n",
    "         -r        :  same as -R, but only start bound must match to count as duplicate\n",
    "         -M        :  sort snos, output only hits to Mapped sites\n",
    "         -U        :  sort snos, output only hits to Unmapped sites\n",
    "         -T <int>  :  sort snos, output only top <int> hits per meth site (def=50)\n", 
    "         -S <score>:  sort snos, require minimum score\n",
    "         -m <score>:  sort snos, don't include hits _over_ max <score>\n",
    "         -e <expr> :  Extract only snos with <expr> in header line\n",
    "         -F        :  Don't sort -- just filter & output in same order\n\n";
}				


($infile) = @ARGV;

open(INFILE,"$infile");

$rDNA_repeat_hits=0;
$last_meth = "Am00";
$ct = -1;
while ($line = <INFILE>) {
    if ($line =~ /^\>\>\s(\S+)\s+(\S+)\s+\((\d+)\-(\d+)\)\s+Cmpl:\s(\S+)\-([ACGU]m)(\d+)\s\((\S+)\)/) {
	$ct++;
	$seq_name[$ct] = $1;
	$sno_scores[$ct] = $2;
	$sno_start[$ct] = $3;
	$sno_end[$ct] = $4;
	$sno_match[$ct] = $5;
	$sno_methnuc[$ct] = $6;
	$sno_meth[$ct] = $7;
	$sno_meth_id[$ct] = $8;

	
	if (($seq_name[$ct] eq "ySc_chr12") && 
	    ((($sno_start[$ct] > 451000) && ($sno_start[$ct] < 471000)) ||
	     (($sno_start[$ct] > 489000) && ($sno_start[$ct] < 491000)))) {
	    $rDNA_repeat = 1;
	    $rDNA_repeat_hits++;
	}
	else {
	    $rDNA_repeat = 0;
	}

	if ((($line =~ /$key/) && !$rDNA_repeat) && 
	    ($sno_scores[$ct] >= $Min_score)) {
	    $key_match = 1;
	}
	else {
	    $ct--;
	    $key_match = 0;
	}
    }
	
    if (($line =~ /Guide\sSeq\sSc:\s(\S+)\s+\((\S+)\s/) && 
	($2 >= $Max_score)  && ($key_match)) {
	$sno_list[$ct] = "";
	$ct--;
	$key_match = 0;
    }

    if (($line =~ /^Meth\ssite/) && $key_match) {
	$sno_mapped[$ct] = 1;

	if ($unmapped_only) {
	    $sno_list[$ct] = "";
	    $ct--;
	    $key_match = 0;
	}
    }
    
    if (($line =~ /^Meth\ssite/) && $key_match) {
	$sno_mapped[$ct] = 1;
    }
    if (($ct >= 0) && $key_match) {
	$sno_list[$ct] .= $line;
    }
}


$total = $ct+1;
print $total," entries read";
if ($rDNA_repeat_hits) {
    print "($rDNA_repeat_hits rDNA hits excluded)";
}
print "\n\n";

if ($Filter_only) {    
    print "Filtering only...\n\n";
    for ($ct=0; $ct < $total; $ct++) {
	print $sno_list[$ct];
    }
    print "$ct entries filtered.\n\n";
    exit(1);
}
    
if ($sort_by_site) {
    
    @sorted_snos = sort { 
	$sno_match[$a] cmp $sno_match[$b] ||
	    $sno_meth[$a] <=> $sno_meth[$b] || 
		$sno_scores[$b] <=> $sno_scores[$a];
    } (0..$total-1);
    
}
elsif ($sort_by_hit) {
    
    @sorted_snos = sort { 
	$seq_name[$a] cmp  $seq_name[$b] ||
	    $sno_start[$a] <=> $sno_start[$b] || 
		$sno_scores[$b] <=> $sno_scores[$a];
    } (0..$total-1);
}

else {
    
    @sorted_snos = sort { 
	$sno_scores[$b] <=> $sno_scores[$a];
    } (0..$total-1);
}

$last_i = -1;
$print_ct = 0;

for $i (@sorted_snos) {
    

    if (($sno_scores[$i] <= $sno_scores[$last_i]) &&
	($sno_start[$i] == $sno_start[$last_i]) &&
	(($sno_end[$i] == $sno_end[$last_i]) || $single_bound_match) &&
	($sno_match[$i] eq $sno_match[$last_i]) &&
	($seq_name[$i] eq $seq_name[$last_i]) &&
	($sno_meth[$i] == $sno_meth[$last_i])) {
	$duplicate_hit = 1;
    }
    else {
	$duplicate_hit = 0;
    }	
    
    if ((!$remove_dups || ($remove_dups && !$duplicate_hit)) && 
	(!$mapped_only || ($mapped_only && $sno_mapped[$i]))) {
	
	if ($sno_meth[$last_i] == $sno_meth[$i]) {
	    $meth_ct++;
	}
	else {
	    $meth_ct = 1;
	}
	
	if ($meth_ct <= $Max_meth_hits) {
	    print $sno_list[$i];
	    $last_i = $i;		
	    $print_ct++;
	}
    }
}

print "\n$print_ct entries sorted & output\n\n";







